﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Documents.RichText;
using Infragistics.Documents.RichText.Html;

namespace RichTextEditorExportHTML
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            // see if there are any ParagraphStyles inside the Styles collection already.  If not add a clone of the normal style.
            if (!xamRichTextEditor1.Document.RootNode.Styles.Any(s => s is ParagraphStyle))
            {
                ParagraphStyle ps = (ParagraphStyle)xamRichTextEditor1.Document.AvailableStyles["Normal"].Clone();
                if (ps != null)
                {
                    if (ps.ParagraphSettings == null)
                        ps.ParagraphSettings = new ParagraphSettings();
                    if (ps.ParagraphSettings.Spacing == null)
                        ps.ParagraphSettings.Spacing = new ParagraphSpacingSettings();
                    ps.ParagraphSettings.Spacing.AfterParagraph = new ParagraphVerticalSpacing(new Extent(0));
                    xamRichTextEditor1.Document.RootNode.Styles.Add(ps);
                }
            }
            else
            {
                // there are already ParagraphStyles in the collection so just modify the existing ones to remove the margin.
                foreach (var richTextStyle in xamRichTextEditor1.Document.RootNode.Styles)
                {
                    if (richTextStyle is ParagraphStyle)
                    {
                        ParagraphStyle ps = richTextStyle as ParagraphStyle;
                        if (ps.ParagraphSettings == null)
                            ps.ParagraphSettings = new ParagraphSettings();
                        if (ps.ParagraphSettings.Spacing == null)
                            ps.ParagraphSettings.Spacing = new ParagraphSpacingSettings();
                        ps.ParagraphSettings.Spacing.AfterParagraph = new ParagraphVerticalSpacing(new Extent(0));
                    }
                }
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            HtmlSerializationProviderExtensions.SaveToHtml(xamRichTextEditor1.Document, "test.html", null);
        }
    }
}
